/* common defines */
/*
 * $Header: /morpork/home/bmh/xtest2/RCS/defs.h,v 1.21 92/12/16 11:08:16 bmh Exp Locker: bmh $
 *
 * Bernard Hatt
 * Camtec Electronics (Ericsson), Leicester, England, LE1 4SA
 * bmh@terminus.ericsson.se
 *
 */

	/* increment this version no. if the client/server protocol is */
	/* changed in any way */
#define VERSION		8

#define DEFSPORT	1622	/* default server UDP port no. */
#define DEFCPORT	1623	/* default client UDP port no. */
#define DEFRPORT	1650	/* default base for robot players */

#define MAXUSERS 	10	/* max no of users. */

#if MAXUSERS >10
#define BASECHAR	'A'	/* use letters if more than 10 users */
#else
#define BASECHAR	'0'	/* use digits if less than 10 users */
#endif

#define MAXROBOTS	(MAXUSERS/2)	/* max no. of robots */

#define SCORES		(MAXUSERS*3)	/* max number of users in score table */

#define MAINX   768  	/* X and Y of main battlefield */
#define MAINY   768   

#define HOSTLEN	10	/* max chars in hostname */
#define FULLHOSTLEN	64	/* length of full hostname */

#define NAMELEN	10	/* max chars in username */
#define FULLNAMELEN	64
#define BUFLEN	128	/* general purpose char buffer */

#define MAINSIZE	2048	/* size of field in pixels */

#define OBJECTSIZE	32	/* size of object grid */
#define OBJECTSCALE	(MAINSIZE/OBJECTSIZE)
#define OBJX		(MAINX/OBJECTSCALE)
#define OBJY		(MAINY/OBJECTSCALE)


#define RADARSIZE	256	/* size of radar screen (pixels) */
#define RADARSCALE	(MAINSIZE/RADARSIZE)
#define ROSCALE		(RADARSIZE/OBJECTSIZE)	/* radar/object scale */

#define SCROLLBAR	8	/* width of scroll bar */
#define SBX		(MAINX/OBJECTSIZE)
#define SBY		(MAINY/OBJECTSIZE)

#define MESSAGESIZE	24
#define DAMAGEBAR	48

#define TANKROT 128     /* number of different tank rotations */
#define TGRID   6       /* size of grid defining tank */
#define T       TGRID


#define	CLEAR	0	/* types of ground */
#define ROUGH	1
#define UNSET	64
#define	BLOCKED	127

#define QUIT		0	/* user quit */
#define	KILLED		1	/* killed */
#define TIMEOUT		2	/* timeout after no responce */
#define DESTROYED	3	/* DestroyWindow event */

#define MAXDAMAGE	128
#define DAMAGESCALE	(RADARSIZE/MAXDAMAGE)
#define EXPSIZE		192	/* size of explosion (pixels dia.) */
#define EXPTIME		60	/* time for explosion (cs) */
#define EXPCONST	100	/* power of explosions */
#define EXPRANGE	(32*32)	/* range for which explosions count as direct hits */

#define STDMOVE	64	/* standard move in pixels/sec */
#define MSTDMOVE (-1*STDMOVE)	/* minus standard move in pixels/sec */
#define STDROT	32	/* standard rotation in pixels/sec */
#define MSTDROT	(-1*STDROT)	/* minus standard rotation in pixels/sec */


#define PI	3.14159265358979323846264338327950

/* function type defs. */

extern char *getenv();

	/* functions in common.c */
int gettime(),rnd(),GetAngle();
void myualarm();

#define SIZE(x) ((x>0)?x:(0-x))
