/*
 * Comms.
 *
 * $Header: /morpork/home/bmh/xtest2/RCS/dgram.c,v 1.11 92/12/16 11:07:35 bmh Exp Locker: bmh $
 *
 * Bernard Hatt
 * Camtec Electronics (Ericsson), Leicester, England, LE1 4SA
 * bmh@terminus.ericsson.se
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>

#include "defs.h"
#include "comms.h"

#define STREAM_TYPE	SOCK_DGRAM

struct hostent *gethostbyname();

int
openread(port)
int port;
{
	int sd;
	struct sockaddr_in name;

	sd=socket(AF_INET,STREAM_TYPE,0);
	if(sd==-1)
	{
		perror("openread()/socket()");
		return(-1);
	}
 	name.sin_family=AF_INET;
	name.sin_addr.s_addr=INADDR_ANY;
	name.sin_port=htons(port);

	if(bind(sd,&name,sizeof(name)))
	{
		perror("openread()/bind()");
		return(-1);
	}
	return(sd);
}

int
readdata(sd,data)
int sd;
DATA *data;
{
	return(read(sd,data,sizeof(DATA)));
}

int
opensend(host,port,ip)
char *host;
int port;
IP *ip;
{
	int ret,sd;
	struct sockaddr_in name;
	struct hostent *hent;
	unsigned long ip_long;

	sd=socket(AF_INET,STREAM_TYPE,0);
	if(sd==-1)
	{
		perror("opensend()/socket()");
		return(-1);
	}

	hent=gethostbyname(host);
	if(hent==NULL)
	{
		if(ip==NULL)
		{
			ip_long=inet_addr(host);
			bcopy((char*)&ip_long,&name.sin_addr,4);
		}
		else
		{
			fprintf(stderr,"Can't find host %s's IP address trying %d.%d.%d.%d\n",host,ip->addr[0]&0xff,ip->addr[1]&0xff,ip->addr[2]&0xff,ip->addr[3]&0xff);
			bcopy(ip->addr,&name.sin_addr,INSWAP(ip->len));
		}
	}
	else
	{
		bcopy(hent->h_addr,&name.sin_addr,hent->h_length);
	}

	name.sin_family=AF_INET;
	name.sin_port=htons(port);

		/* connect port */
	ret=connect(sd,&name,sizeof(name));
	if(ret==-1)
	{
		perror("opensend()/connect()");
		return(-1);
	}
	return(sd);
}

int
senddata(sd,data)
int sd;
DATA *data;
{
	return(write(sd,data,sizeof(DATA)));
}

int
getipaddr(host,ip)
char *host;
IP *ip;
{
	struct hostent *hent;

	hent=gethostbyname(host);
	if(hent==NULL)
		return(-1);

	bcopy(hent->h_addr,ip->addr,hent->h_length);
	ip->len=OUTSWAP(hent->h_length);
	return(0);
}
