/*
 * Server
 *
 * $Header: /morpork/home/bmh/xtest2/RCS/xtbd.c,v 1.29 92/12/16 11:08:11 bmh Exp Locker: bmh $
 *
 * Bernard Hatt
 * Camtec Electronics (Ericsson), Leicester, England, LE1 4SA
 * bmh@terminus.ericsson.se
 *
 */

#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <signal.h>
#include <errno.h>

#include "defs.h"
#include "comms.h"

PLAYER player[MAXUSERS];	/* players tanks */
char	field[OBJECTSIZE][OBJECTSIZE];
SCORE	score[SCORES];		/* score table */
int noscores=0;			/* number of scores in score table */

int sintable[TANKROT];
int costable[TANKROT];


DATA pdata;

DATA rdata,sdata;
int rsd,ssd;
char mbuf[BUFLEN];
int lastsend=0;

char *progname;

int debug=0;
int scoreflag=1;

int
isuseron(name,host)
char *name,*host;
{
	int i;
	for(i=0;i<MAXUSERS;i++)
	{
		if(strcmp(player[i].user.username,name))
			continue;
		if(strcmp(player[i].user.hostname,host))
			continue;
		return(i);
	}
	return(-1);
}

void
getscore(id)	/* get score for player[id] */
int id;
{
	int i;
	for(i=0;i<noscores;i++)
	{
		if(strcmp(player[id].user.username,score[i].user.username))
			continue;
		if(strcmp(player[id].user.hostname,score[i].user.hostname))
			continue;
		player[id].killed=score[i].killed;
		player[id].kills=score[i].kills;
		return;
	}
	player[id].killed=0;
	player[id].kills=0;
	if(i==SCORES)
	{
		fprintf(stderr,"Run out of score table entries\n");
	}
	else
	{
		strcpy(score[noscores].user.username,player[id].user.username);
		strcpy(score[noscores].user.hostname,player[id].user.hostname);
		noscores++;
	}
}

void
dumpscores()	/* dump all scores */
{
	int i;
	int killed,kills,total;
	int on;
	char ch;
	for(i=0;i<noscores;i++)
	{
		ch=' ';
		kills=score[i].kills;
		killed=score[i].killed;
		on=isuseron(score[i].user.username,score[i].user.hostname);
		if(on!=(-1))
		{
			ch='*';
			kills=player[on].kills;
			killed=player[on].killed;
		}
		total=kills+killed;
		if(total==0)
			total=1;
		printf("%12s@%-12s %c games %-4d, kills %-4d (%3d%%), killed %-4d (%3d%%)\n",score[i].user.username,score[i].user.hostname,ch,total,kills,((100*kills)/total),killed,((100*killed)/total));
	}
}

void
setscore(id)	/* set score for player[id] */
int id;
{
	int i;
	for(i=0;i<noscores;i++)
	{
		if(strcmp(player[id].user.username,score[i].user.username))
			continue;
		if(strcmp(player[id].user.hostname,score[i].user.hostname))
			continue;
		score[i].killed=player[id].killed;
		score[i].kills=player[id].kills;
		printf("Score for %s@%s is %d/%d\n",score[i].user.username,score[i].user.hostname,player[id].kills,player[id].killed);
		return;
	}
	fprintf(stderr,"User not in score table!\n");
}

int
sqdist(x1,y1,x2,y2)	/* square of distance between (x1,y1) and (x2,y2) */
int x1,y1,x2,y2;
{
	int dx,dy;
	dx=(x1-x2);
	dy=(y1-y2);
	return(dx*dx+dy*dy);
}

void
sendplayers()	/* send all players their positions */
{
	int i;
	pdata.type=OUTSWAP(T_REPLY);

	for(i=0;i<MAXUSERS;i++)
	{
		pdata.extra.reply.pos[i].x=OUTSWAP(player[i].pos.x);
		pdata.extra.reply.pos[i].y=OUTSWAP(player[i].pos.y);
		pdata.extra.reply.pos[i].rot=OUTSWAP(player[i].pos.rot);
	}

	for(i=0;i<MAXUSERS;i++)
		if(player[i].pos.x!=-1)
			senddata(player[i].ssd,&pdata);
}

void
sendmessage(str)	/* send a message to all players */
char *str;
{
	int i;
	sdata.type=OUTSWAP(T_MESSAGE);
	strcpy(sdata.extra.message.text,str);
	for(i=0;i<MAXUSERS;i++)
		if(player[i].pos.x!=-1)
			senddata(player[i].ssd,&sdata);
}

void
fireshell(id)	/* player (id) has fired */
int id;
{
	int newtime,i,j;
	int srot,dist;
	int sx,sy;
	int dx,dy;
	int hflag=0,kflag=0,killed=0;

	newtime=gettime();
	if((newtime>(250+player[id].firetime))&&(player[id].damage<MAXDAMAGE))
	{
		player[id].firetime=newtime;
		srot=player[id].pos.rot;
		sx=player[id].pos.x;
		sy=player[id].pos.y;
		dx=costable[srot]/4;
		dy=sintable[srot]/4;
		for(i=0;i<16;i++)
		{
			sx-=dx;
			sy-=dy;
			if((sx>MAINSIZE)||(sy>MAINSIZE)||(sx<0)||(sy<0))
				break;
			if(field[sx/OBJECTSCALE][sy/OBJECTSCALE]==BLOCKED)
				break;
			for(j=0;j<MAXUSERS;j++)
			{
				if(id==j)
					continue;
				if(player[j].pos.x==(-1))
					continue;
				if(sqdist(sx,sy,player[j].pos.x,player[j].pos.y)<(TGRID*TGRID*6*6))
				{
					hflag++;
					break;
				}
			}
			if(hflag)
				break;
		}
		/* sx,sy is position of shell hit */
		sdata.type=OUTSWAP(T_EXPLOSION);
		sdata.extra.explosion.x=OUTSWAP(sx);
		sdata.extra.explosion.y=OUTSWAP(sy);
		for(i=0;i<MAXUSERS;i++)
		{
			if(player[i].pos.x==(-1))
				continue;
			if(player[i].damage>=MAXDAMAGE)
				continue;
			dist=sqdist(sx,sy,player[i].pos.x,player[i].pos.y);
			if(dist<EXPRANGE)
				player[i].damage+=MAXDAMAGE/2;
			else
				player[i].damage+=(EXPCONST*(MAXDAMAGE/2)/((dist-EXPRANGE)+EXPCONST));
			if(player[i].damage>=MAXDAMAGE)
			{
				killed=i;
				kflag++;
			}
			sdata.extra.explosion.damage[i]=OUTSWAP(player[i].damage);
		}

		if(kflag&&(killed!=id))
		{
			player[id].damage=0;
			sdata.extra.explosion.damage[id]=OUTSWAP(player[id].damage);
			player[id].kills++;
		}
		
		for(i=0;i<MAXUSERS;i++)
		{
			if(player[i].pos.x==(-1))
				continue;
			senddata(player[i].ssd,&sdata);
		}

		if(kflag)
		{
			if(killed==id)
				sprintf(mbuf,"%s@%s committed suicide",player[killed].user.username,player[killed].user.hostname);
			else
				sprintf(mbuf,"%s@%s killed by %s@%s",player[killed].user.username,player[killed].user.hostname,player[id].user.username,player[id].user.hostname);
			sendmessage(mbuf);
		}

	}
}

void
dosignon()	/* deal with signon from user */
{
	int rndx,rndy;
	int id,ssd,i,cflag,attempts;
	/* find free slot */
	id=(-1);
	for(i=0;i<MAXUSERS;i++)
	if(player[i].pos.x==(-1))
	{
		id=i;
		break;
	}
	ssd=opensend(rdata.extra.signon.hostname,INSWAP(rdata.extra.signon.port),&(rdata.extra.signon.ip));
	if(ssd==(-1))
	{
		fprintf(stderr,"%s: Connecting to %s/%d failed\n",progname,rdata.extra.signon.hostname,INSWAP(rdata.extra.signon.port));
	}
	else
	{
		sdata.type=OUTSWAP(T_ACCEPT);
		if(INSWAP(rdata.extra.signon.version)!=VERSION)
		{
			sdata.type=OUTSWAP(T_REJECT);
			sprintf(sdata.extra.reject.text,"Client/Server version no. mismatch (%d,%d)",INSWAP(rdata.extra.signon.version),VERSION);
		}
		if(id==(-1))
		{
			sdata.type=OUTSWAP(T_REJECT);
			strcpy(sdata.extra.reject.text,"Too many users");
		}
		if(isuseron(rdata.extra.signon.username,rdata.extra.signon.hostname)!=(-1))
		{
			sdata.type=OUTSWAP(T_REJECT);
			strcpy(sdata.extra.reject.text,"User already signed on");
		}
		if(sdata.type==OUTSWAP(T_REJECT))
		{
			senddata(ssd,&sdata);
			printf("Sent reject \"%s\"\n",sdata.extra.reject.text);
			close(ssd);
			return;
		}
		attempts=0;
		player[id].ssd=ssd;
		do
		{
			attempts++;
			cflag=0;
			rndx=rnd(OBJECTSIZE);
			rndy=rnd(OBJECTSIZE);
			for(i=0;i<MAXUSERS;i++)
			{
				if(i==id)
					continue;
				if(player[i].pos.x==(-1))
					continue;
				if(sqdist(rndx*OBJECTSCALE+(OBJECTSCALE/2),rndy*OBJECTSCALE+(OBJECTSCALE/2),player[i].pos.x,player[i].pos.y)<(OBJECTSCALE*OBJECTSCALE*49))
				{
					if(attempts<5)
						cflag++;
					break;
				}
			}
		}
		while(((field[rndx][rndy]!=CLEAR)||(cflag))&&(attempts<10));

		player[id].pos.x=rndx*OBJECTSCALE+(OBJECTSCALE/2);
		player[id].pos.y=rndy*OBJECTSCALE+(OBJECTSCALE/2);
		player[id].pos.rot=0;
		player[id].move.rot=0;
		player[id].move.linear=0;
		player[id].t=gettime();
		player[id].restime=gettime();
		player[id].damage=0;
		strncpy(player[id].user.username,rdata.extra.signon.username,HOSTLEN);
		player[id].user.username[NAMELEN-1]='\0';
		strncpy(player[id].user.hostname,rdata.extra.signon.hostname,NAMELEN);
		player[id].user.hostname[HOSTLEN-1]='\0';
		getscore(id);
		printf("Sent accept (id=%d)\n",id);
		sdata.extra.accept.id=OUTSWAP(id);
		for(i=0;i<MAXUSERS;i++)
		{
			strcpy(sdata.extra.accept.players[i].username,player[i].user.username);
			strcpy(sdata.extra.accept.players[i].hostname,player[i].user.hostname);
			sdata.extra.accept.killed[i]=OUTSWAP(player[i].killed);
			sdata.extra.accept.kills[i]=OUTSWAP(player[i].kills);
		}
		for(i=0;i<MAXUSERS;i++)
			if(player[i].pos.x!=-1)
				senddata(player[i].ssd,&sdata);
		sprintf(mbuf,"Signon from %s@%s",player[id].user.username,player[id].user.hostname);
		sendmessage(mbuf);
	}
}

void
dosignoff(thisid,reason)	/* deal with signoff from user */
int thisid,reason;
{
	int i;

	switch(reason)
	{
	case QUIT:
		printf("signoff (QUIT) from %d\n",thisid);
		if(player[thisid].damage>(MAXDAMAGE/2))
			player[thisid].killed++;
		break;
	case KILLED:
		printf("signoff (KILLED) from %d\n",thisid);
		player[thisid].killed++;
		break;
	case TIMEOUT:
		printf("signoff (TIMEOUT) from %d\n",thisid);
		break;	
	case DESTROYED:
		printf("signoff (DESTROYED) from %d\n",thisid);
		break;	
	}
	if((reason!=KILLED)&&(reason!=DESTROYED))
	{
		sprintf(mbuf,"Signoff from %s@%s",player[thisid].user.username,player[thisid].user.hostname);
		sendmessage(mbuf);
	}
	setscore(thisid);

	*(player[thisid].user.username)='\0';
	*(player[thisid].user.hostname)='\0';

	if(scoreflag)
		dumpscores();

	sdata.type=OUTSWAP(T_ACCEPT);
	for(i=0;i<MAXUSERS;i++)
	{
		strcpy(sdata.extra.accept.players[i].username,player[i].user.username);
		strcpy(sdata.extra.accept.players[i].hostname,player[i].user.hostname);
		sdata.extra.accept.killed[i]=OUTSWAP(player[i].killed);
		sdata.extra.accept.kills[i]=OUTSWAP(player[i].kills);
	}
	for(i=0;i<MAXUSERS;i++)
		if(player[i].pos.x!=-1)
			senddata(player[i].ssd,&sdata);

	player[thisid].pos.x=(-1);
	close(player[thisid].ssd);
}

void
moveplayers()	/* move all players */
{
	int i,j,newtime,diff,td,max;
	int testx,testy,testrot,scale;
	int dx,dy,cflag=0;
	int stage;

	for(i=0;i<MAXUSERS;i++)
	{
		stage=0;
		if(player[i].pos.x==(-1))
			continue;
		newtime=gettime();
		td=newtime-player[i].t;
		player[i].t=newtime;
		if((gettime()-player[i].restime)>500)
		{
			sdata.type=OUTSWAP(T_ALIVE);
			senddata(player[i].ssd,&sdata);
		}

		if((gettime()-player[i].restime)>1000)
		{
			dosignoff(i,TIMEOUT);
		}
		
		scale=100;

		diff=player[i].move.rot-player[i].pos.rot;


		testx=player[i].pos.x/OBJECTSCALE;
		testy=player[i].pos.y/OBJECTSCALE;
		if(field[testx][testy]==ROUGH)
			scale=200;
		if(diff>(TANKROT/2))
			diff-=TANKROT;

		if(diff<(TANKROT/(-2)))
			diff+=TANKROT;

		max=((td*STDROT)/scale)+1;

		if(diff<0)
			diff=((td*diff-99)/100);
		else
			if(diff>0)
				diff=((td*diff+99)/100);

		if(diff>max)
			diff=max;
		if(diff<(max*-1))
			diff=(max*-1);

		player[i].pos.rot=(player[i].pos.rot+diff+TANKROT)%TANKROT;

		testrot=player[i].pos.rot;
		dx=((TGRID*6)*costable[testrot])/STDMOVE;
		dy=((TGRID*6)*sintable[testrot])/STDMOVE;
		testx=(player[i].pos.x+player[i].move.linear*dx);
		testy=(player[i].pos.y+player[i].move.linear*dy);

		stage=1;
		if((testx>MAINSIZE)||(testy>MAINSIZE)||(testx<0)||(testy<0))
			goto loopend;
		stage=2;
		if(field[testx/OBJECTSCALE][testy/OBJECTSCALE]==BLOCKED)
			goto loopend;

		testrot=(player[i].pos.rot+TANKROT/14)%TANKROT;
		dx=((TGRID*6)*costable[testrot])/STDMOVE;
		dy=((TGRID*6)*sintable[testrot])/STDMOVE;
		testx=(player[i].pos.x+player[i].move.linear*dx);
		testy=(player[i].pos.y+player[i].move.linear*dy);

		stage=3;
		if((testx>MAINSIZE)||(testy>MAINSIZE)||(testx<0)||(testy<0))
			goto loopend;
		stage=4;
		if(field[testx/OBJECTSCALE][testy/OBJECTSCALE]==BLOCKED)
			goto loopend;

		testrot=(player[i].pos.rot-(TANKROT/14)+TANKROT)%TANKROT;

		dx=((TGRID*6)*costable[testrot])/STDMOVE;
		dy=((TGRID*6)*sintable[testrot])/STDMOVE;
		testx=(player[i].pos.x+player[i].move.linear*dx);
		testy=(player[i].pos.y+player[i].move.linear*dy);

		stage=5;
		if((testx>MAINSIZE)||(testy>MAINSIZE)||(testx<0)||(testy<0))
			goto loopend;
		stage=6;
		if(field[testx/OBJECTSCALE][testy/OBJECTSCALE]==BLOCKED)
			goto loopend;

		testx=player[i].pos.x+(player[i].move.linear*td*costable[player[i].pos.rot])/scale;
		testy=player[i].pos.y+(player[i].move.linear*td*sintable[player[i].pos.rot])/scale;

		for(j=0;j<MAXUSERS;j++)
		{
			if(i==j)
				continue;
			if(player[j].pos.x==(-1))
				continue;
			if(sqdist(testx,testy,player[j].pos.x,player[j].pos.y)<(TGRID*TGRID*6*6*2))
			{
				if(debug)
					printf("Collision %d->%d\n",i,j);
				cflag++;
				break;
			}
		}

		if(!cflag)
		{
			player[i].pos.x=testx;
			player[i].pos.y=testy;
			stage=0;
		}


loopend:	if(debug)
			if(stage!=0)
				printf("Tank %d blocked at stage %d\n",i,stage);
	}
}

void
doalarm()	/* what to do when alarm expires */
{
	int i;
	for(i=0;i<MAXUSERS;i++)
	{
		if(player[i].pos.x==(-1))
			continue;
		if(player[i].move.fire)
			fireshell(i);
			
	} 
	moveplayers();
	sendplayers();
	signal(SIGALRM,doalarm);
	myualarm(100000);	/* reset 1/10th sec alarm */
}

main(argc,argv)
int argc;
char *argv[];
{
	int i,j,rn,thisid,reason;
	int port=DEFSPORT;
	char *p;

	srand(time(0));

	progname=argv[0];

	for(i=1;i<argc;i++)
	{
		p=argv[i]; 
		if(*p++=='-')
		{
			switch(*p++)
			{
			case 'p':
				if(*p=='\0')
					port=atoi(argv[++i]);
				else
					port=atoi(p);
				break;
			case 'd':
				debug=(!debug);
				break;
			case 's':
				scoreflag=(!scoreflag);
				break;
			default:
				fprintf(stderr,"Usage: %s -p portno\n",argv[0]);
			}
		}
	}

	fprintf(stderr,"%s: XTankBattle server, datagram size is %d (V%d)\n",progname,sizeof(DATA),VERSION);

	srand(time(0));
	for(i=0;i<MAXUSERS;i++)
	{
		player[i].pos.x=(-1);
		player[i].user.username[0]='\0';
		player[i].user.hostname[0]='\0';
	}

	for(i=0;i<TANKROT;i++)
	{
		sintable[i]=(int)(0.5+(double)STDMOVE*sin(((double)i*2.0*PI)/TANKROT));
		costable[i]=(int)(0.5+(double)STDMOVE*cos(((double)i*2.0*PI)/TANKROT));
	}

	for(i=0;i<OBJECTSIZE;i++)
		for(j=0;j<OBJECTSIZE;j++)
		{
			field[i][j]=CLEAR;
			rn=rnd(8);
			if(rn==1)
				field[i][j]=BLOCKED;
			if((rn==4)||(rn==6))
				field[i][j]=ROUGH;
		}

	signal(SIGALRM,doalarm);

	rsd=openread(port);
	if(rsd==-1)
	{
		fprintf(stderr,"%s: Unable to open port %d for reading\n",argv[0],port);
		exit(1);
	}
	while(1)
	{
		fflush(stdout);
		myualarm(100000);	/* 1/10th sec alarm */
		if(readdata(rsd,&rdata)!=sizeof(DATA))
		{
			if(errno!=EINTR)
				printf("Bad data (Config mismatch?)\n");
		}
		else
		{
			myualarm(0);	/* turn off alarm */
			switch(INSWAP(rdata.type))
			{
			case T_SIGNON:
				printf("signon\n");
				printf("host %s/%d\n",rdata.extra.signon.hostname,INSWAP(rdata.extra.signon.port));
				printf("user %s\n",rdata.extra.signon.username);

				dosignon();
				break;
			case T_DATAREQ:
				i=INSWAP(rdata.extra.datareq.lineno);
				ssd=player[INSWAP(rdata.id)].ssd;
				sdata.type=OUTSWAP(T_FIELDDATA);
				sdata.extra.field.lineno=OUTSWAP(i);
				memcpy(sdata.extra.field.object,&field[i][0],OBJECTSIZE);
				senddata(ssd,&sdata);
				break;
			case T_ACCEPT:
				printf("accept\n");
				break;
			case T_REJECT:
				printf("reject\n");
				break;
			case T_MOVE:
				thisid=INSWAP(rdata.id);
				player[thisid].move.rot=INSWAP(rdata.extra.move.rot);
				player[thisid].move.linear=INSWAP(rdata.extra.move.linear);
				player[thisid].move.fire=INSWAP(rdata.extra.move.fire);
				player[thisid].restime=gettime();

				if(player[thisid].move.fire)
					fireshell(thisid);

				moveplayers();
				if((gettime()-lastsend)>4)
				{
					sendplayers();
					lastsend=gettime();
				}

				break;
			case T_REPLY:
				printf("reply\n");
				break;
			case T_SIGNOFF:
				thisid=INSWAP(rdata.id);
				reason=INSWAP(rdata.extra.signoff.reason);
				if(player[thisid].pos.x!=(-1))
					dosignoff(thisid,reason);
				break;
			case T_ALIVE:
				thisid=INSWAP(rdata.id);
				player[thisid].restime=gettime();
/*				printf("%d is alive\n",thisid);*/
				break;
			default:
				printf("Unknown datagram type %d (0x%x)\n",INSWAP(rdata.type),INSWAP(rdata.type));
			}
		}
	}
}
